Page MenuHomePhabricator

"User-facing feature release" session at 2015 MediaWiki Developer Summit
Closed, ResolvedPublic

Description

https://www.mediawiki.org/wiki/MediaWiki_Developer_Summit_2015#Schedule
Monday 26, 1:00pm

The existing ways of releasing user-facing features have proved to have severe limitations during the Media Viewer release. As someone who went through that storm, I feel like many of the organizational issues we encountered haven't been addressed yet. This is a critical issue, as years of hard work can potentially get a very hostile response when the release date comes, and unprepared engineers can find themselves with a big crisis to handle with many hotfixes to produce in a short period of time.

While some areas have been improved since, such as the introduction of the design research team as a way to validate changes, much still has to be discussed.

Slides: https://docs.google.com/presentation/d/1zAiBdDZnw1-JXWKkYlM1U8GdpuRuL5zaNCx5S9mWRoQ/edit?usp=sharing
Etherpad: http://etherpad.wikimedia.org/p/user-facing-feature-release-discussion

Concrete actionable suggestions surfaced during this session:

  • Gradual deployment tools
  • Advertising beta features
  • Only use public mailing lists for product design and development
  • Make meetings public by default, even if we think nobody will watch of be interested (weekly team meetings, etc.)
  • Give unregistered (logged out) users access to beta features T76580
  • Easier creation/signup/info for newsletters M12
  • Publicly visible/editable product dashboard tracking acceptance criteria, and how/why those were set
  • Allow time in product development process for learning and iteration (build / research / iterate / build)
  • Reach out to subsections of the movement who don't currently have a voice (eg. readers, potential users)
  • Set up a blocking set of criteria for technical fitness before release (eg. is the test coverage appropriate?)
  • Executable acceptance tests written as user stories used for success measurement

Event Timeline

Gilles created this task.Jan 7 2015, 2:23 PM
Gilles raised the priority of this task from to Needs Triage.
Gilles updated the task description. (Show Details)
Gilles added subscribers: Gilles, Qgil.
Qgil triaged this task as Normal priority.Jan 8 2015, 12:17 PM

@Gilles Thanks for creating this. I've actually been working with the PMs on getting a basic framework in place for our end-to-end product development process (see draft https://www.mediawiki.org/wiki/Wikimedia_Product_Development/Product_Development_Process). It's pretty basic right now, but the goal is to eventually have a unified methodology that describes how features are selected, designed, validated, rolled out, how to involve our community, etc -- many of the bullet points you list. And when I say "unified", I don't mean that every team does things that same exact way (to your "standardization" bullet). But I do think there should be an overall toolkit that teams can choose from, and that we add to over time as we develop more sophisticated means of rolling out, testing, etc.

So I think there are two things we should do here:

  1. Let's set up some time to walk through the work that the PMs have done (i.e., the mediawiki page above).
  2. I know Erik is considering having a session on process at the developer summit. Let's chat about whether we should consolidate sessions or keep things separate.

Does that work?

Jdlrobson moved this task from Plenary to Backlog on the MediaWiki-Developer-Summit-2015 board.
Jdlrobson moved this task from Backlog to Plenary on the MediaWiki-Developer-Summit-2015 board.

Since this is currently planned to be a plenary session, I think these should be consolidated.

Qgil renamed this task from User-facing feature release, plenary session at 2015 MediaWiki Developer Summit to "User-facing feature release" session at 2015 MediaWiki Developer Summit.Jan 12 2015, 10:19 PM
Gilles added a subscriber: RobLa.Jan 13 2015, 5:21 PM

I'm happy to see this merged into a larger topic, feel free to edit the description. I don't have to be on the stage side of things either, it just seemed to @RobLa and I like a major topic to discuss. It's all the same to me whether I take a part organizing it or not, all that matters to me is those questions being discussed collectively.

Qgil added a comment.Jan 14 2015, 6:34 PM

See the new location of this session on Monday 26 at 1pm, right after lunch.

I suggest you spice up this title. It might make sense when you know what the topic is about, but otherwise it sounds pretty gray and not related with the very hot and intense topic that addresses.

Elitre added a subscriber: Elitre.Jan 15 2015, 10:29 AM
Gilles updated the task description. (Show Details)Jan 15 2015, 3:21 PM
Gilles updated the task description. (Show Details)

I've prepared slides for this session: https://docs.google.com/presentation/d/1zAiBdDZnw1-JXWKkYlM1U8GdpuRuL5zaNCx5S9mWRoQ/edit?usp=sharing

I've tried to use a format where @Rdicerb and @howief can list what's in the works to address some of these issues. I'm hoping we can collectively discuss each question, starting with either of you explaining what your plan is for the issues that concern your teams and then turning to the group for discussing the issue further.

Gilles updated the task description. (Show Details)Jan 26 2015, 8:10 AM
Gilles updated the task description. (Show Details)

Thanks for setting this up, Gilles!

I think it would be useful to include highlights from our Media Viewer Retrospective Summary for this session:
https://docs.google.com/a/wikimedia.org/document/d/1sUxMfr4_WcaHX0hgL7WdVGHV9zw2p4vCxLo0AzDj5Dg/edit#

We plan to post the final draft on Mediawiki.org in coming days, but I also recommend that we use some of this retrospective's highlights during today’s 1pm session on 'User-facing feature release'.

The current version of these slides only show ‘What went wrong with the Media Viewer release’, which seems misleading to me. There are many things that went well with this project, which I think should be identified as well, to give a fair and accurate overview of what we learned.

It may also be worth it to share a few of the key findings from this research report, published last week:
https://www.mediawiki.org/wiki/Multimedia/Media_Viewer/Research_2014

I aim to be there at 1pm today, to answer any questions about this project from a product perspective, but recommend that our key findings be reflected in the slides, to provide relevant context for people not familiar with the project.

Thanks, everyone!

Thanks Fabrice. This session is meant to be primarily about process, so let's keep it focused. For example, I wouldn't recommend going into the research findings because many of the findings are specific to MediaViewer.

This shouldn't turn into a Media Viewer presentation. Media Viewer only serves as a brief concrete example of where the existing process didn't deliver. I will briefly mention what went well, but the point of this session is for people to discuss the remaining issues, not for me to do a presentation. People specifically interested in the Media Viewer-centric big picture and reports can find them.

This comment was removed by Elitre.

Very very early stage Community Engagement process thinking: https://www.mediawiki.org/wiki/Community_Engagement_%28Product%29/Collaboration_Process/Draft - I will add to the slide deck as well.

OK, thanks for your clarifications, you guys! I think you did the right thing and the discussion went really well. So well that I linked to it at the end of the retrospective document, to point out to other ideas for future releases. Well done!

MZMcBride added a subscriber: MZMcBride.
Qgil added a comment.Jan 27 2015, 6:58 AM

Please update the description with the achievements of this session. Thank you in advance.

Elitre closed this task as Resolved.Mar 16 2015, 4:55 PM
Elitre claimed this task.